#include "MainWindow.h"

void press(QWidget *widget,QMouseEvent *event){}
void mv(QWidget *widget,QMouseEvent *event){}
void release(QWidget *widget,QMouseEvent *event){}
void dbclick(QWidget *widget,QMouseEvent *event){}
void itsMe(MyClass *widget){}

MainWindow::MainWindow(QWidget *parent, const char *name ): QWidget( parent, name )
{
  int i;

  prepare();

  shortcut=new up(this,"shortcuts");
  shortcut->move(0,30);
  shortcut->show();

  chooser=new left(this,"chooser");
  chooser->move(0,70);
  chooser->show();

  file = new QPopupMenu();
  CHECK_PTR( file );
  file->insertItem("&New", this, SLOT(newOne()), CTRL+Key_N );
  file->insertItem("&Open",  this, SLOT(open()), CTRL+Key_O );
  saveItem=file->insertItem("&Save", this, SLOT(save()), CTRL+Key_S );
  saveAsItem=file->insertItem("Save &As ...",this,SLOT(saveAs()),CTRL+Key_A); 
  closeItem=file->insertItem( "&Close", this, SLOT(closeIt()), CTRL+Key_W );
  file->insertSeparator();

  file->insertSeparator();
  file->insertItem( "E&xit", this, SLOT(exit()), CTRL+Key_Q );
  file->setItemEnabled(saveItem,FALSE);
  shortcut->setOn(3,FALSE);
  file->setItemEnabled(saveAsItem,FALSE);
  file->setItemEnabled(closeItem,FALSE);

  edit = new QPopupMenu();
  CHECK_PTR( edit );
  undoItem=edit->insertItem( "&Undo", this, SLOT(undo()),CTRL+Key_U );
  edit->insertSeparator();
  cutItem=edit->insertItem("&Cut",this,SLOT(cut()),CTRL+Key_X);
  edit->setItemEnabled(cutItem,FALSE);
  shortcut->setOn(4,FALSE);
  copyItem=edit->insertItem("C&opy",this,SLOT(copy()),CTRL+Key_C);
  edit->setItemEnabled(copyItem,FALSE);
  shortcut->setOn(5,FALSE);
  pasteItem=edit->insertItem("&Paste",this,SLOT(paste()),CTRL+Key_V);
  edit->setItemEnabled(undoItem,FALSE);
  shortcut->setOn(7,FALSE);
  edit->setItemEnabled(pasteItem,FALSE);
  shortcut->setOn(6,FALSE);
  edit->insertSeparator();
  prefsItem=edit->insertItem("P&roperties",this,SLOT(prefs()),CTRL+Key_R);
  edit->setItemEnabled(prefsItem,FALSE);

  tools = new QPopupMenu();
  CHECK_PTR( tools );
  genItem=tools->insertItem( "&Generate", this, SLOT(gen()),CTRL+Key_G );
  tools->setItemEnabled(genItem,FALSE);
  shortcut->setOn(8,FALSE);
  srcItem=tools->insertItem("&Class tree",this,SLOT(classTree()),CTRL+Key_T);
  shortcut->setOn(9,FALSE);
  tools->setItemEnabled(srcItem,FALSE);

  QPopupMenu *help = new QPopupMenu;
  CHECK_PTR( help );
  help->insertItem( "&About", this, SLOT(about()), CTRL+Key_H );
  help->insertItem( "About &Qt", this, SLOT(aboutQt()) );

  menu = new QMenuBar( this );
  CHECK_PTR( menu );
  menu->insertItem( "&File", file );
  menu->insertItem( "&Edit", edit );
  menu->insertItem("Too&ls",tools);
  menu->insertSeparator();
  menu->insertItem( "&Help", help );
  menu->setSeparator( QMenuBar::InWindowsStyle );
  
  middle=new Dialog(this,"dialog");
  middle->setGeometry(60,70,280,280);

  helptext=new down(this,"downpanel");
  helptext->move(0,360);
  helptext->show();
  
  QString temp("BuildIT! v. ");
  temp+=VERSION;
  setCaption(temp.data());

  setMinimumSize(350,400);
  setMaximumSize(350,400);
  resize(350,400);
  
  code=AR;
  clicked=FALSE;
  canUndo=FALSE;
  undoProps=FALSE;
  canSave=FALSE;
  canPaste=FALSE;
  canPrefs=FALSE;
  canClose=TRUE;
  PasteIT=FALSE;
  lastTouched=NULL;
  active=NULL;

  for (i=0; i < NUMFEATURE1; i++) 
    undoF1[i] = new QString(30);
  for (i=0; i < NUMFEATURE2; i++) 
    undoF2[i] = -1;
  
  for(i=0;i<NUMPROJECTS;i++)
    state[i]=0;

  pasteTree=new MyTree();
  undoTree=new MyTree();
}

void MainWindow::prepare()
{
  int uid;
  struct passwd *info;


  if(getenv("BIT_HOME")==NULL)   
    {
      printf("BIT_HOME evironment variable EMPTY!\ntemplates will be taken from ./\n");
      bigPath=QString("./");	
    }
  else
    {
      bigPath=QString(getenv("BIT_HOME"));
      if(bigPath[bigPath.length()-1]!='/')
	bigPath+=QString("/");
    }

  uid=getuid();
  info=getpwuid(uid);
  homePath=QString(info->pw_dir);
  if(homePath[homePath.length()-1]!='/')
    homePath+=QString("/");

  QDir home(homePath.data());
  
  if(home.exists(".build"))
    {
      if(! home.exists(".build/out"))
	home.mkdir(".build/out",FALSE);
      if(! home.exists(".build/tmp"))
	home.mkdir(".build/tmp",FALSE);
      if(! home.exists(".build/saves"))
	home.mkdir(".build/saves",FALSE); 
    }
  else
    {
      home.mkdir(".build",FALSE);
      home.mkdir(".build/out",FALSE);
      home.mkdir(".build/saves",FALSE);
      home.mkdir(".build/tmp",FALSE);
    }
}


void MainWindow::newOne()
{
  int i,current;

  current=freeNum();
  if (current<0)
      QMessageBox::information( this, "warning","too many projects !");
  else 
    { 
      canPrefs=TRUE;canSave=TRUE;canClose=FALSE;
      edit->setItemEnabled(prefsItem,TRUE);
      
      file->setItemEnabled(saveItem,TRUE);
      shortcut->setOn(3,TRUE);
      file->setItemEnabled(saveAsItem,TRUE);
      file->setItemEnabled(closeItem,TRUE);
      tools->setItemEnabled(genItem,TRUE);
      shortcut->setOn(8,TRUE);
      tools->setItemEnabled(srcItem,TRUE);
      shortcut->setOn(9,TRUE);
      MyClass *tmp=new MyClass();
      lastTouched=tmp;
      lastTouched->setTraced(tmp);
      lastTouched->counter++;
      
      if(active!=NULL)
	delete active;
      active=new Frame(tmp,"active");
      setActive(tmp,FALSE);
      
      QString newVN("RootClass");
      newVN+=QString().setNum(current);

      QString id=QString().setNum(lastTouched->counter);
      QString name;
      name=id+" "+newVN;
      tmp->setName(name);

      tmp->setType(AP);

      QString caption=homePath+".build/saves/noname";
      caption+=QString().setNum(current);
      caption+=".jbd";
      tmp->setHomeDir(homePath);
      tmp->setFileName(caption);


      QString *f1[NUMFEATURE1];  
      for (i = 0; i < NUMFEATURE1; i++) 
	f1[i] = new QString(30);

      int f2[NUMFEATURE2];
      for (i = 0; i < NUMFEATURE2; i++) 
	f2[i] = -1;

      *f1[0] = id.copy();
      //      *f1[3] = caption.copy();      // zamiana kolejnosci 3 z 1
      *f1[3] = "path"; 
      *f1[2] = "MyClass";
      *f1[1] = name.copy();
     
      f2[0] = NUMFEATURE2;
      f2[1] = tmp->x();
      f2[2] = tmp->y();
      f2[3] = tmp->width();
      f2[4] = tmp->height();
      
      QColor col;
      col = tmp->backgroundColor();
      f2[5] = col.red();
      f2[6] = col.green();
      f2[7] = col.blue();
      col = tmp->foregroundColor();
      f2[8] = col.red();
      f2[9] = col.green();
      f2[10] = col.blue();
      
      QFont f;
      f = tmp->font();
      *f1[4] = f.family();
      f2[11] = f.pointSize();
      f2[12] = f.weight();
      if (f.italic() == TRUE) f2[13] = 1;
      else f2[13] = 0;
      
      f2[14]=1;
      f2[20]=AP;

      tree[current].Add(f1, f2);
      tmp->which = current;
      middle->addProject(tmp);
      
      tmp->setMouseTracking(TRUE);
      connect(tmp,SIGNAL(press(QWidget *,QMouseEvent *)),SLOT(takePress(QWidget *,QMouseEvent *)));
      connect(tmp,SIGNAL(release(QWidget *,QMouseEvent *)),SLOT(takeRelease(QWidget *,QMouseEvent *)));
      connect(tmp,SIGNAL(itsMe(MyClass *)),SLOT(setTouched(MyClass *)));
      connect(tmp,SIGNAL(dbclick(QWidget *,QMouseEvent *)),SLOT(takeDbClick(QWidget *,QMouseEvent *)));
      connect(tmp,SIGNAL(mv(int,int)),SLOT(watchMouse(int,int)));
      connect(tmp,SIGNAL(leave()),SLOT(clear()));

      tmp->watchIt(tmp);
      tmp->show();
   
      for (i = 0; i < NUMFEATURE1; i++) if (f1[i]) delete f1[i];
      state[current]=1;
    }
}

bool MainWindow::ShowWidget(MyTree *t, QWidget *parent,bool undo,bool first)
{
  int ch = t->GetNumChildren(),what,i;
  QWidget *next;
  QString name;
  
  lastTouched->counter++;
  name=*t->GetFeature1(1);

  //only for undo

  if(*(t->GetFeature1(2)) == "MyClass")
    {
      next=toUndo;
      what=AP;
    }

  //PUSHBUTTON
  
  if(*(t->GetFeature1(2)) == "MyPushButton")  
    {
      if(!undo)
	{
	  MyPushButton *tmp = new MyPushButton((const char*) *t->GetFeature1(3), parent,name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyPushButton *)toUndo)->setText(t->GetFeature1(3)->data());
	  ((MyPushButton *)next)->evt.clear();
	}
      what=PB;
    }
  
  //RADIOBUTTON
  
  if (*(t->GetFeature1(2)) == "MyRadioButton")
    {
      if(!undo)
	{
	  MyRadioButton *tmp = new MyRadioButton((const char*) *t->GetFeature1(3), parent, name.data());
	  next = tmp;
	}
      else
	{
	  ((MyRadioButton *)toUndo)->setText(t->GetFeature1(3)->data());
	  next=toUndo;
	  ((MyRadioButton *)next)->evt.clear();
	}

      ((MyRadioButton *)next)->setGroup((t->GetFeature1(5))->data());
      if(t->GetFeature2(20)==1)
	((MyRadioButton *)next)->setChecked(TRUE);
      else
	((MyRadioButton *)next)->setChecked(FALSE);
      what=RB;
    }
      
  //CANVAS
  
  if (*(t->GetFeature1(2)) == "MyCanvas")
    {
      if(!undo)
	{
	  MyCanvas *tmp = new MyCanvas(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyCanvas *)next)->evt.clear();
	}
      what=CS;
    }
  
  //CHOICE
  
  if (*(t->GetFeature1(2)) == "MyChoice")
    {
      int i;

      if(!undo)
	{
	  MyChoice *tmp = new MyChoice(parent, name.data());
	  next = tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyChoice *)next)->evt.clear();
	}

      ((MyChoice *)next)->clear();
      for (i=0; i<t->GetFeature2(20); i++)
	{
	  MyTree *temptree;
	  QString name = *(t->GetChildren(i))->GetFeature1(0);
	  temptree = t->Find(&name.copy());
	  ((MyChoice *)next)->insertItem(temptree->GetFeature1(3)->data());	
	}
      ((MyChoice *)next)->setCurrentItem(t->GetFeature2(21));
      what=CO;
    }

  //LIST
  
  if (*(t->GetFeature1(2)) == "MyList")
    {
      int i;

      if(!undo)
	{
	  MyList *tmp = new MyList(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyList *)next)->evt.clear();
	}

      ((MyList *)next)->clear();
      for (i=0; i<t->GetFeature2(20); i++)
	{
	  MyTree *temptree;

	  QString name = *((t->GetChildren(i))->GetFeature1(0));
	  temptree = t->Find(&name.copy());
	  ((MyList *)next)->insertItem(temptree->GetFeature1(3)->data());
	  if(temptree->GetFeature2(20)==1)
	    ((MyList *)next)->setSelected(i,TRUE);
	}
      if(t->GetFeature2(21)==1)
	((MyList *)next)->setMulti(TRUE);
      else
	((MyList *)next)->setMulti(FALSE);
      what=LI;
    }

  //TEXTFIELD

  if (*(t->GetFeature1(2)) == "MyTextField")
    {
      if(!undo)
	{
	  MyTextField *tmp = new MyTextField(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyTextField *)next)->evt.clear();
	}
      ((MyTextField *)next)->setText((t->GetFeature1(3))->data());
      ((MyTextField *)next)->setEcho((t->GetFeature1(5))->data());
      if(t->GetFeature2(20)==1)
	((MyTextField *)next)->setEdit(TRUE);
      else
	((MyTextField *)next)->setEdit(FALSE);
      what=TF;
    }

  //TEXTAREA

  if (*(t->GetFeature1(2)) == "MyTextArea")
    {
      if(!undo)
	{
	  MyTextArea *tmp = new MyTextArea(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyTextArea *)next)->evt.clear();
	}

      if(t->GetFeature2(20)==1)
	((MyTextArea *)next)->setEdit(TRUE);
      else
	((MyTextArea *)next)->setEdit(FALSE);
      what=TA;
      ((MyTextArea *)next)->setScr(t->GetFeature2(21)); 
      QString txt;
      QString temp2=t->GetFeature1(1)->copy();
      
      QString temp1 = temp2.right(temp2.length()-temp2.find(" "));
      temp1=temp1.stripWhiteSpace();
      QString name = homePath+".build/tmp/" + temp1.copy() + ".tmp";

      QFile f2(name);
      ((MyTextArea *)next)->clear();
      if (f2.open(IO_ReadOnly) != FALSE)
	{
	  QTextStream t( &f2 );
	  QString s;          
	  while ( !t.eof() ) {
	    s = t.readLine(); 
	    ((MyTextArea *)next)->append((const char*) s);
	  }  
	  f2.close();
	}
    }

  //SCROLLBAR

  if (*(t->GetFeature1(2)) == "MyScrollBar")
    {
      if(!undo)
	{
	  MyScrollBar *tmp = new MyScrollBar(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyScrollBar *)next)->evt.clear();
	}
      if((t->GetFeature2(20)==1)||(t->GetFeature2(20)==-1))
	((MyScrollBar *)next)->setOrientation(MyScrollBar::Horizontal);
      else
	((MyScrollBar *)next)->setOrientation(MyScrollBar::Vertical);
      ((MyScrollBar *)next)->setVal(t->GetFeature2(21));
      ((MyScrollBar *)next)->setMax(t->GetFeature2(22));
      ((MyScrollBar *)next)->setMin(t->GetFeature2(23));
      ((MyScrollBar *)next)->setPS(t->GetFeature2(24));
      what=SB;
    }

  //MENUBAR

  if (*(t->GetFeature1(2)) == "MyMenuBar")
    {
      if(!undo)
	{
	  MyMenuBar *tmp = new MyMenuBar(parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyMenuBar *)next)->evt.clear();
	}
      ((MyClass *)parent)->setMenu((MyMenuBar *)next,TRUE);
      ((MyMenuBar *)next)->setGeometry(0,0,parent->width(),20);
      what=MB;
    }

  //MENU

  if (*(t->GetFeature1(2)) == "MyMenu")
    {
      MyMenuItem *it;
      int i;

      if(!undo)
	{
	  MyMenu *tmp = new MyMenu((const char*) *t->GetFeature1(3),parent,name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyMenu *)next)->setText(t->GetFeature1(3)->data());
	  ((MyMenu *)next)->evt.clear();
	}

      // do it if it's a help menu
      if(t->GetFeature2(23)==1)
	((MyMenu *)next)->help=TRUE;
      else
	((MyMenu *)next)->help=FALSE;
      ((MyMenu *)next)->setShc(t->GetFeature2(20),t->GetFeature2(21),*t->GetFeature1(6));
      
      if(!undo)
	((MyMenuBar *)parent)->addMenu((MyMenu *)next);
      ((MyMenuBar *)parent)->adjust();

      ((MyMenu *)next)->items.clear();
      for (i=0; i<t->GetFeature2(22); i++)
	{
	  MyTree *temptree;
	  QString name = *((t->GetChildren(i))->GetFeature1(0));
	  temptree = t->Find(&name.copy());
	  it=new MyMenuItem(*temptree->GetFeature1(3),temptree->GetFeature2(24));
	  if(temptree->GetFeature2(22)==1)
	    {
	      it->setCB(TRUE);
	      if(temptree->GetFeature2(23)==1)
		it->setState(TRUE);
	      else
		it->setState(FALSE);
	    }
	  else
	      it->setCB(FALSE);
	  it->setKeys(*temptree->GetFeature1(6));
	  (((MyMenu *)next)->items).append(it);
	}
      what=ME;
    }
  
  //LABEL
  
 
  if (*(t->GetFeature1(2)) == "MyLabel")
    {
      if(!undo)
	{
	  MyLabel *tmp = new MyLabel((const char*) *t->GetFeature1(3),parent, name.data());
	  next=tmp;
	}
      else
	{
	  next=toUndo;
	  ((MyLabel *)next)->evt.clear();
	}

      switch  (t->GetFeature2(20))
	{
	case 0:
	  ((MyLabel *)next)->setAlignment(AlignLeft|AlignVCenter);
	  break;
	case 1:
	  ((MyLabel *)next)->setAlignment(AlignCenter);
	  break;
	case 2:
	  ((MyLabel *)next)->setAlignment(AlignRight|AlignVCenter);	    
	  break;
	}
      what=LA;
    }
  // evets
  for(i=0;i<t->GetFeature2(19);i++)
    in(what,next,t->GetFeature1(10+i));
  
  //end of events
  if((what!=ME)&&(what!=MB))  //for menu don't set geometry & colors
   {
     next->setGeometry(t->GetFeature2(1), t->GetFeature2(2), t->GetFeature2(3), t->GetFeature2(4));  

     QColor bcol(t->GetFeature2(5), t->GetFeature2(6), t->GetFeature2(7));
     QColor fcol(t->GetFeature2(8), t->GetFeature2(9), t->GetFeature2(10));
     
     QPalette w_palette=next->palette();
     QColorGroup normal((w_palette.normal()).foreground(),
			bcol,
			(w_palette.normal()).light(),
			(w_palette.normal()).dark(),
			(w_palette.normal()).mid(),
			fcol,
			(w_palette.normal()).base());
     
     QPalette new_palette(normal,normal,normal);
     next->setPalette(new_palette);
   }
  
  if(first)
    setUndo(next,ADD);

  //fonts section
  bool ital;
  if (t->GetFeature2(13) == 1) 
    ital = TRUE;
  else 
    ital = FALSE;
  QFont f((const char*) *t->GetFeature1(4), t->GetFeature2(11), t->GetFeature2(12), ital);
  next->setFont(f);
  //end of fonts section
           
  if(undo)
    {
      toUndo->setName(name.data());
      if(undoCMD==RM)
	setUndo(next,ADD);

      return TRUE;      
    }
  else
    {
      next->setMouseTracking(TRUE);
      connect(next,SIGNAL(mv(QWidget *,QMouseEvent *)),SLOT(takeMove(QWidget *,QMouseEvent *)));
      connect(next,SIGNAL(press(QWidget *,QMouseEvent *)),SLOT(takePress(QWidget *,QMouseEvent *)));
      connect(next,SIGNAL(release(QWidget *,QMouseEvent *)),SLOT(takeRelease(QWidget *,QMouseEvent *)));      
      connect(next,SIGNAL(dbclick(QWidget *,QMouseEvent *)),SLOT(takeDbClick(QWidget *,QMouseEvent *)));
      lastTouched->watchIt(next);
      
      next->show(); 
    }

  lastTouched->setTraced(next);
  //something special for few classes :)
  if ((what==CO)||(what==LI)||(what==ME))
    return TRUE;
  
  if (ch != 0) 
    {
      for (i = 0; i < ch; i++)
	ShowWidget(t->GetChildren(i), next,FALSE,FALSE);
      return TRUE;
    }
   else
     return TRUE;
}

void MainWindow::ShowReadTree(MyTree *t, QString s,int current)
{
  int i,ch;

  canPrefs=TRUE;
  edit->setItemEnabled(prefsItem,TRUE);
  
  file->setItemEnabled(saveItem,TRUE);
  shortcut->setOn(3,TRUE);
  file->setItemEnabled(saveAsItem,TRUE);
  file->setItemEnabled(closeItem,TRUE);
  tools->setItemEnabled(genItem,TRUE);
  shortcut->setOn(8,TRUE);
  tools->setItemEnabled(srcItem,TRUE);
  shortcut->setOn(9,TRUE);
  edit->setItemEnabled(cutItem,TRUE);
  shortcut->setOn(4,TRUE);
  edit->setItemEnabled(copyItem,TRUE);
  shortcut->setOn(5,TRUE); 
 
  MyClass *tmp=new MyClass();

  /* it is last touched */
  lastTouched=tmp;
  lastTouched->setTraced(tmp);

  tmp->counter = 1;

  /* set variable  name */
  QString id=QString().setNum(lastTouched->counter);

  tmp->setName(*t->GetFeature1(1));

  tmp->setHomeDir(homePath);
  tmp->setFileName(s.data());
  tmp->which=current;

  // set type frame aplet or window 
  tmp->setType(AP);
  // add to list
  middle->addProject(tmp);
  
  // set type and title 
  tmp->setType(t->GetFeature2(20));
  if(t->GetFeature2(20)==FR)
    tmp->setTitle(*t->GetFeature1(5));

  // fill events list
  for(i=0;i<t->GetFeature2(19);i++)
    in(AP,tmp,t->GetFeature1(10+i));

  tmp->setMouseTracking(TRUE);
  tmp->setGeometry(t->GetFeature2(1), t->GetFeature2(2), t->GetFeature2(3), t->GetFeature2(4));
  connect(tmp,SIGNAL(press(QWidget *,QMouseEvent *)),SLOT(takePress(QWidget *,QMouseEvent *)));
  connect(tmp,SIGNAL(release(QWidget *,QMouseEvent *)),SLOT(takeRelease(QWidget *,QMouseEvent *)));
  connect(tmp,SIGNAL(itsMe(MyClass *)),SLOT(setTouched(MyClass *)));
  connect(tmp,SIGNAL(dbclick(QWidget *,QMouseEvent *)),SLOT(takeDbClick(QWidget *,QMouseEvent *)));
  connect(tmp,SIGNAL(mv(int,int)),SLOT(watchMouse(int,int)));
  connect(tmp,SIGNAL(leave()),SLOT(clear()));
  tmp->watchIt(tmp);
  tmp->show();
  
  // colors & font
   QColor bcol(t->GetFeature2(5), t->GetFeature2(6), t->GetFeature2(7));
   QColor fcol(t->GetFeature2(8), t->GetFeature2(9), t->GetFeature2(10));

   QPalette w_palette=tmp->palette();
   QColorGroup normal((w_palette.normal()).foreground(),
		      bcol,
		      (w_palette.normal()).light(),
		      (w_palette.normal()).dark(),
		      (w_palette.normal()).mid(),
		      fcol,
		      (w_palette.normal()).base());
   
   QPalette new_palette(normal,normal,normal);
   tmp->setPalette(new_palette);

   ch = t->GetNumChildren();
   if (ch != 0)
     for (i = 0; i < ch; i++)
       ShowWidget(t->GetChildren(i), tmp);
}


void MainWindow::open()
{
  int current;
  current=freeNum();
  if (current<0)
    QMessageBox::information( this, "warning","too many projects !");
  else 
    { 
      QString tmp;
      tmp=homePath+QString(".build/saves");
      QString s(QFileDialog::getOpenFileName(tmp.data(),"*.jbd") );
      if(s.length()>0)
	{
	  if(middle->isOpen(s))
	    {
	      tree[current].File2Tree(s,homePath);
	      state[current]=1;
	      ShowReadTree(&tree[current],s,current);
	    }
	  else
	    QMessageBox::information( this, "warning","this file is already open !");
	}
    }
}

void MainWindow::save()
{
  if(canSave)
    {
      canClose=TRUE;
      saveIt(lastTouched->getFileName(),FALSE);
    }
}

void MainWindow::saveAs()
{
  if(canSave)
    {
      canClose=TRUE;
      QString tmp=homePath+QString(".build/saves");

      QString s=QFileDialog::getSaveFileName(tmp.data(),"*jbd");
      if(s.length()==0)
	lastTouched->setFileName(lastTouched->getFileName());
      else{
	if (s.findRev(".jbd") == -1) 
	  s.append(".jbd");
	saveIt(s,TRUE);
      }
    }
}

void MainWindow::saveIt(QString name,bool val)
{
  if(val && QFile().exists(name.data()))
  {	 
    int pos=name.findRev("/");
    int hm=name.length()-pos;
    QString tmp1=name.right(hm-1);
    QString tmp("File ");
    tmp+=tmp1+" exists! Overwrite it ?";
    switch( QMessageBox::information( this, "warning",tmp.data(),"&Yes", "&No", "&Cancel",0,2 ) ) 
      {
      case 0:
	// tree[whichLast()].SetFeature1(4, name);
	tree[whichLast()].SetFeature2(3, lastTouched->width());
	tree[whichLast()].SetFeature2(4, lastTouched->height());
	tree[whichLast()].Tree2File(name,homePath);
	lastTouched->setFileName(name);
	middle->changeProject(lastTouched);
	break;
      case 1:
	break;
      case 2:
	break;
      }
  }
  else
    {
      // tree[whichLast()].SetFeature1(4, name);
      tree[whichLast()].SetFeature2(3, lastTouched->width());
      tree[whichLast()].SetFeature2(4, lastTouched->height());
      tree[whichLast()].Tree2File(name,homePath);
      lastTouched->setFileName(name);
      middle->changeProject(lastTouched);
    }
}

void MainWindow::closeIt()
{
  if(lastTouched!=NULL)
    {
      if(!canClose)
     	{
	  QString tmp=lastTouched->getFileName();
	  int pos=tmp.findRev("/");
	  int hm=tmp.length()-pos;
	  QString tmp1=tmp.right(hm-1);

	  tmp="Save ";
	  tmp+=tmp1;
	  tmp+=" before closing ?\n";

	  switch( QMessageBox::information( this, "warning",tmp.data(),"&Yes", "&No", "&Cancel",0,2 ) ) 	    {
	    case 0:
	      saveIt(lastTouched->getFileName(),FALSE);
	    case 1: 
	      state[whichLast()]=0;	      
	      tree[whichLast()].Remove(tree[whichLast()].GetFeature1(0));
	      lastTouched->hide();
	      middle->rmProject(lastTouched);
	      //	      lastTouched=NULL;

	      edit->setItemEnabled(undoItem,FALSE);canUndo=FALSE;
	      shortcut->setOn(7,FALSE);

	      if(middle->getNum()==0)
		{ 
		  file->setItemEnabled(saveItem,FALSE);
		  canSave=FALSE;
		  shortcut->setOn(3,FALSE);
		  file->setItemEnabled(saveAsItem,FALSE);
		  file->setItemEnabled(closeItem,FALSE);
		  canClose=FALSE;
		  tools->setItemEnabled(genItem,FALSE);
		  shortcut->setOn(8,FALSE);
		  tools->setItemEnabled(srcItem,FALSE);
		  shortcut->setOn(9,FALSE);
		  edit->setItemEnabled(prefsItem,FALSE);
	     	}

	      edit->setItemEnabled(cutItem,FALSE);
	      shortcut->setOn(4,FALSE);
	      edit->setItemEnabled(copyItem,FALSE);
	      shortcut->setOn(5,FALSE);
	      edit->setItemEnabled(pasteItem,FALSE);
	      shortcut->setOn(6,FALSE);
	      break;
	    case 2: 
	      break;
	    }
      	} //canClose TRUE
      else
	{
	  state[whichLast()]=0;
	  tree[whichLast()].Remove(tree[whichLast()].GetFeature1(0));
	  lastTouched->hide();
	  middle->rmProject(lastTouched);
	  //lastTouched=NULL;	  

	  edit->setItemEnabled(undoItem,FALSE);canUndo=FALSE;
	  shortcut->setOn(7,FALSE);
	  if(middle->getNum()==0)
	    {
	      file->setItemEnabled(saveItem,FALSE);canSave=FALSE;
	      shortcut->setOn(3,FALSE);
	      file->setItemEnabled(saveAsItem,FALSE);
	      file->setItemEnabled(closeItem,FALSE);canClose=FALSE;
	      tools->setItemEnabled(genItem,FALSE);
	      shortcut->setOn(8,FALSE);
	      tools->setItemEnabled(srcItem,FALSE);
	      shortcut->setOn(9,FALSE); 
	      edit->setItemEnabled(prefsItem,FALSE);
	    }
	  edit->setItemEnabled(cutItem,FALSE);
	  shortcut->setOn(4,FALSE);
	  edit->setItemEnabled(copyItem,FALSE);
	  shortcut->setOn(5,FALSE);
	  edit->setItemEnabled(pasteItem,FALSE);
	  shortcut->setOn(6,FALSE);
	}
    }
  else
    printf("lastTouched==NULL !!\n");
}

void MainWindow::classTree()
{
  ShowTree *show = new ShowTree(&tree[whichLast()],bigPath);
  show->displayTree(TRUE);
}

void MainWindow::gen()
{
  Generator s(tree[whichLast()].GetNumAllChildren(),this, homePath, bigPath);
  s.generateSource(&tree[whichLast()]);

  QString temp1=tree[whichLast()].GetFeature1(1)->copy();
  int pos=temp1.findRev(" ");
  int hm=temp1.length()-pos;
  temp1 = temp1.right(hm-1);

  QString name;
  name.sprintf(homePath+".build/out/%s.java", (const char*) temp1);
  
  switch (tree[whichLast()].GetFeature2(20))
    {
    case AP:
      s.finishSource(homePath, homePath+ ".build/tmp/applet.tmp", name);
      s.genHtml(&tree[whichLast()]);
      break;
    case FR:
      s.finishSource(homePath, homePath+ ".build/tmp/frame.tmp", name); 
      break;
    case WN:
      s.finishSource(homePath, homePath+ ".build/tmp/window.tmp", name);
    }
  QString text("Your source file is :\n~/.build/out/");
  text+=temp1+QString(".java");
  QMessageBox::information( this,"Generation complete",text.data(),"&Close");
}

void MainWindow::exit()
{
  int i;
  
  i=middle->getNum();
  if(i>0)
    {
      qApp->quit();
      QString tmp=QString().setNum(i);
      QString text("Do you really want to exit?\nYou have ");
      if(i==1)
	text+=tmp+" "+"project still open !\n";
      else
	text+=tmp+" "+"projects still open !\n";
	
  
      switch( QMessageBox::information( this,"Attention!",text.data(),"&Yes", "&No", "&Cancel",0,2 ) ) 
	{
	case 0: 
	  qApp->quit();
	  middle->end();
	case 1: 
	  break;
	}
    }
  else
    qApp->quit();
}
void MainWindow::setUndo(QWidget *widget,int cmd)
{
  edit->setItemEnabled(undoItem,TRUE);
  shortcut->setOn(7,TRUE);
  canClose=FALSE;

  QString tmp=QString(widget->name());
  undoID=tmp.left(tmp.find(" "));
  undoCMD=cmd;
  undoT=whichLast();
  switch (cmd)
    {
    case RM:
      toUndo=widget->parentWidget(); 
      break;
    case ADD:
      toUndo=widget;
      break;
    case MV:
      toUndo=widget;
      break;
    case CHANGE:
      QString id_tmp,id;
      int i,j,nn;
      bool flat;

      toUndo=widget;
      undoParent=widget->parentWidget();

      //copy tree to pastetree
      QString nm=QString(toUndo->className());

      if((nm!=QString("MyChoice"))&&(nm!=QString("MyList"))&&(nm!=QString("MyMenu")))
	flat=TRUE;
      else
	flat=FALSE;

      QString *children[50];
      for (i = 0; i < 50; i++) 
	children[i] = new QString(30);
      
      nn=0;
      tree[whichLast()].getSub(tree[whichLast()].Find(&undoID),children,nn);

      delete(undoTree);
      undoTree=new MyTree();
      
      QString  *f1t[NUMFEATURE1];
      int       f2t[NUMFEATURE2];

      for (i=0; i<NUMFEATURE1; i++) 
	f1t[i]=new QString(30);

      MyTree *tempTree;      
      for(i=0;i<nn;i++)
	{
	  tempTree=tree[whichLast()].Find(children[i]);
	  
	  for(j=0;j<NUMFEATURE1;j++)
	    *f1t[j]=tempTree->GetFeature1(j)->copy();
	   
	  *f1t[0]=children[i]->replace(0,undoID.length(),QString("1"));
	  
	  //because of move
	  for(j=0;j<NUMFEATURE2;j++)
	    f2t[j]=tempTree->GetFeature2(j);

	  if(i==0)
	    {
	      f2t[0]=NUMFEATURE2;
	      f2t[1]=undoX;
	      f2t[2]=undoY;
	      f2t[3]=undoW;
	      f2t[4]=undoH;
	    }
          undoTree->Add(f1t,f2t);
	}
      break;      
    }
}



void MainWindow::undo()
{
  if((canUndo) && (whichLast()==undoT))
    {
      MyTree *tempTree;

      switch(undoCMD)
	{
	case RM:
	  copyWidget(toUndo,0,0,TRUE);
	  break;	
	case ADD:
	  lastTouched->setTraced(toUndo);
	  cut();
	  break;
	case MV:
	  toUndo->setGeometry(undoX,undoY,undoW,undoH);
	  tempTree=tree[whichLast()].Find(&undoID);
	  tempTree->SetFeature2(1,undoX);
	  tempTree->SetFeature2(2,undoY);
	  tempTree->SetFeature2(3,undoW);
	  tempTree->SetFeature2(4,undoH);
	  setActive(toUndo,TRUE);
	  break;
	case CHANGE:
	  QString *f1t[NUMFEATURE1],id,id_tmp;
	  int f2t[NUMFEATURE2];
	  int i,j,nn;
	  bool flat;

	  for (i=0; i<NUMFEATURE1; i++) 
	    f1t[i]=new QString(30);
	  
	  if((QString(toUndo->className())!=QString("MyChoice"))&&(QString(toUndo->className())!=QString("MyList"))&&(QString(toUndo->className())!=QString("MyMenu")))
	    flat=TRUE;
	  else
	    flat=FALSE;

	  QString *children[50];
	  for (i = 0; i < 50; i++) 
	    children[i] = new QString(30);

	  nn=0;
	  id=QString("1");
	  undoTree->getSub(undoTree->Find(&id),children,nn);

	  for(i=0;i<nn;i++)
	    {
	      tempTree=undoTree->Find(children[i]);
	  
	      for(j=0;j<NUMFEATURE1;j++)
		*f1t[j]=tempTree->GetFeature1(j)->copy();
	   
	      *f1t[0]=children[i]->replace(0,1,undoID);
	  
	      for(j=0;j<NUMFEATURE2;j++)
		f2t[j]=tempTree->GetFeature2(j);

	      if(nn>1)
		tree[whichLast()].Remove(children[i]);

	      if(tree[whichLast()].Find(children[i])!=NULL)
		tree[whichLast()].Update(f1t,f2t);
	      else
		tree[whichLast()].Add(f1t,f2t);
	    }
	  tempTree=tree[whichLast()].Find(&undoID);
	  
	  ShowWidget(tempTree,undoParent,TRUE);
	  if(toUndo->className()!=QString("MyClass"))
	    setActive(toUndo,TRUE);
	  break;
	}

      edit->setItemEnabled(undoItem,FALSE);
      shortcut->setOn(7,FALSE);
      canUndo=FALSE;
    }
}

void MainWindow::cut()
{
  QWidget *tmp;
  QString id_tmp,id;
  int i,j;
  if(lastTouched!=NULL)
    {
      tmp=lastTouched->traced();
      if(QString(tmp->className())==QString("MyMenuBar"))
	lastTouched->setMenu(tmp,FALSE);
      setActive(tmp,FALSE);
      canUndo=TRUE;undoProps=FALSE;

      setUndo(tmp,RM);

      if(QString(tmp->className())==QString("MyMenu"))
	((MyMenuBar *)(lastTouched->mmb))->rmMenu((MyMenu *)tmp);    

      canPaste=TRUE;
      edit->setItemEnabled(pasteItem,TRUE);
      shortcut->setOn(6,TRUE);

      id_tmp=QString(tmp->name());
      id=id_tmp.left(id_tmp.find(" ")).copy();

      //copy removed tree to pastetree
      int nn=0;QString *children[30];
      for (i = 0; i < 30; i++) 
	children[i] = new QString(30);

      nn=0;
      tree[whichLast()].getSub(tree[whichLast()].Find(&id),children,nn);
      id_tmp=QString("1");
      
      delete(pasteTree);
      pasteTree=new MyTree();
      
      QString *f1t[NUMFEATURE1];
      int f2t[NUMFEATURE2];

      for (i=0; i<NUMFEATURE1; i++) 
	f1t[i]=new QString(30);
      MyTree *tempTree;
      
      for(i=0;i<nn;i++)
	{
	  tempTree=tree[whichLast()].Find(children[i]);
	  
	  for(j=0;j<NUMFEATURE1;j++)
	    *f1t[j]=tempTree->GetFeature1(j)->copy();
	   
	  *f1t[0]=children[i]->replace(0,id.length(),QString("1"));
	  
	  for(j=0;j<NUMFEATURE2;j++)
	    f2t[j]=tempTree->GetFeature2(j);
	  
          pasteTree->Add(f1t,f2t);
	}
      //remove component from main tree
      tree[whichLast()].Remove(&id);
      delete(tmp);
    }
}

void MainWindow::copy()
{  
  QWidget *tmp;
  QString id_tmp,id;
  int i,j,nn;

  if(lastTouched!=NULL)
    {
      tmp=lastTouched->traced();

      setActive(tmp,FALSE);
      canUndo=TRUE;undoProps=FALSE;canPaste=TRUE;
      edit->setItemEnabled(pasteItem,TRUE);
      shortcut->setOn(6,TRUE);

      id_tmp=QString(tmp->name());
      id=id_tmp.left(id_tmp.find(" ")).copy();

      //copy tree to pastetree
      QString *children[30];
      for (i = 0; i < 30; i++) 
	children[i] = new QString(30);

      nn=0;
      tree[whichLast()].getSub(tree[whichLast()].Find(&id),children,nn);
      id_tmp=QString("1");
      
      delete(pasteTree);
      pasteTree=new MyTree();
      
      QString *f1t[NUMFEATURE1];
      int f2t[NUMFEATURE2];

      for (i=0; i<NUMFEATURE1; i++) 
	f1t[i]=new QString(30);
      MyTree *tempTree;
      
      for(i=0;i<nn;i++)
	{
	  tempTree=tree[whichLast()].Find(children[i]);
	  
	  for(j=0;j<NUMFEATURE1;j++)
	    *f1t[j]=tempTree->GetFeature1(j)->copy();
	   
	  *f1t[0]=children[i]->replace(0,id.length(),QString("1"));
	  
	  for(j=0;j<NUMFEATURE2;j++)
	    f2t[j]=tempTree->GetFeature2(j);
	  
          pasteTree->Add(f1t,f2t);
	}
      //remove component from main tree
    }
}

void MainWindow::paste()
{
  display("click to paste");
  PasteIT=TRUE;
}


void MainWindow::prefs()
{
  if(lastTouched!=NULL)
    {
      canUndo=TRUE;undoProps=TRUE;
      setUndo(lastTouched->traced(),CHANGE);
      setActive(lastTouched->traced(),FALSE);
      Props *tmp=new Props(&tree[whichLast()],lastTouched->traced(),homePath);
    }
}

void MainWindow::about()
{
  QString temp("           BuildIT! version ");
  temp+=VERSION;
  temp+="\n                 written by \nMichal Switala             scisly@mat.uni.torun.pl\nArtur Prusakiewicz         prusak@mat.uni.torun.pl\n http://www.mat.uni.torun.pl/~scisly/buildit/";
  QMessageBox::about( this, "BuildIT!",temp.data());
}


void MainWindow::aboutQt()
{
    QMessageBox::aboutQt( this, "Qt" );
}

void MainWindow::setActive(QWidget *widget,bool what,bool move)
{
 if(what)
   {
     active->move(widget->x()-1,widget->y()-1);
     active->resize(widget->width()+2,widget->height()+2);
     if(!move)
       {
	 active->raise();
	 widget->raise();
	 active->show();
       }
   }
 else
   active->hide();
}



void MainWindow::takeMove(QWidget *widget,QMouseEvent *event)
{
  int x,y,w,h,x1,y1,x2,y2,x3,y3;

  x=event->x();y=event->y();
  x1=widget->x();y1=widget->y();w=widget->width();h=widget->height();

  watchWidget(widget);

  if(clicked)
  {
    canUndo=TRUE;
    undoProps=TRUE;
    canClose=FALSE;
    setUndo(widget,CHANGE);
    if(QString(widget->className()).contains("Menu")>0)
      place=0;
    switch(place)
      {
      case 1:widget->setGeometry(x1+x,y1+y,w-x,h-y);break;  // NW
      case 2:widget->setGeometry(x1+x,y1,w-x,h);break;      // W
      case 3:widget->setGeometry(x1+x,y1,w-x,y);break;      // SW
      case 4:widget->setGeometry(x1,y1,w,y);break;          // S
      case 5:widget->setGeometry(x1,y1,x,y);break;          // SE
      case 6:widget->setGeometry(x1,y1,x,h);break;          // E
      case 7:widget->setGeometry(x1,y1+y,x,h-y);break;      // NE
      case 8:widget->setGeometry(x1,y1+y,w,h-y);break;      // N
      case 9:widget->move(x1+x-clickX,y1+y-clickY);break;   // move
      case 10:widget->move(x1+x-clickX,y1);break;           // Menu
      }
    if(place>0)
      {
	widget->repaint(); 
	setActive(widget,TRUE,TRUE);
	
	QString Id(widget->name());
	int pos=Id.find(" ");
	QString temp=Id.left(pos); 
	
	MyTree *tmp; 
	tmp = tree[whichLast()].Find(&temp);
	tmp->SetFeature2(1, widget->x());
	tmp->SetFeature2(2, widget->y());
	tmp->SetFeature2(3, widget->width());
	tmp->SetFeature2(4, widget->height());
      }
  } 
  else
    {
      if((x<MR)&&(y<MR))  // polnocny zachod
	{
	  widget->setCursor(sizeAllCursor);
	  place=1;
	}
      else
	{
	  if((x<MR))  // zachod
	    {
	      widget->setCursor(sizeHorCursor);
	      place=2;
	    }
	  if(y<MR) // polnoc
	    {
	      widget->setCursor(sizeVerCursor);
	      place=8;
	    }
	}
      if((x<MR)&&(y>h-MR)) // poludniowy zachod
	{
	  widget->setCursor(sizeAllCursor);
	  place=3;
	}
      else
	{
	  if(y>h-MR) // polodnie
	    {
	      widget->setCursor(sizeVerCursor);
	      place=4;
	    }
	}
      if((y>h-MR)&&(x>w-MR)) //polodniowy wschod
	{
	  widget->setCursor(sizeAllCursor);
	  place=5;
	}
      else
	{
	  if(x>w-MR) //wschod
	    {
	      widget->setCursor(sizeHorCursor);
	      place=6;
	    } 
	}
      if((x>w-MR)&&(y<MR)) //  polnocny wschod
	{
	  widget->setCursor(sizeAllCursor);
	  place=7;
	}
      if((x>=MR)&&(y>=MR)&&(x<=w-MR)&&(y<=h-MR)) //wnetrze
	{
	 place=9;
	 widget->setCursor(arrowCursor);
	}
      if((x<MR)&&(y<MR))  // polnocny zachod
	{
	  widget->setCursor(sizeAllCursor);
	  place=1;
	}
      else
	{
	  if((x<MR))  // zachod
	    {
	      widget->setCursor(sizeHorCursor);
	      place=2;
	    }
	  if(y<MR) // polnoc
	    {
	      widget->setCursor(sizeVerCursor);
	      place=8;
	    }
	}
      if((x<MR)&&(y>h-MR)) // poludniowy zachod
	{
	  widget->setCursor(sizeAllCursor);
	  place=3;
	}
      else
	{
	  if(y>h-MR) // poludnie
	    {
	      widget->setCursor(sizeVerCursor);
	      place=4;
	    }
	}
      if((y>h-MR)&&(x>w-MR)) //poludniowy wschod
	{
	  widget->setCursor(sizeAllCursor);
	  place=5;
	}
      else
	{
	  if(x>w-MR) //wschod
	    {
	      widget->setCursor(sizeHorCursor);
	      place=6;
	    } 
	}
      if((x>w-MR)&&(y<MR)) //  polnocny wschod
	{
	  widget->setCursor(sizeAllCursor);
	  place=7;
	}
      if((x>=MR)&&(y>=MR)&&(x<=w-MR)&&(y<=h-MR)) //wnetrze
	{
	 place=9;
	 widget->setCursor(arrowCursor);
	}
    }
} // END OF takeMove

bool MainWindow::takePress(QWidget *widget,QMouseEvent *event)
{
  QString wname(widget->className());
  int x,y,x1,y1,w,h,x2,y2,x3,y3;
  x=event->x();y=event->y();
  
  canSave=TRUE;
  file->setItemEnabled(saveItem,TRUE);
  shortcut->setOn(3,TRUE);
  file->setItemEnabled(saveAsItem,TRUE);
  file->setItemEnabled(closeItem,TRUE);
  tools->setItemEnabled(genItem,TRUE);
  shortcut->setOn(8,TRUE); 
  tools->setItemEnabled(srcItem,TRUE);
  shortcut->setOn(9,TRUE);
  file->setItemEnabled(srcItem,TRUE);
  edit->setItemEnabled(cutItem,TRUE);
  shortcut->setOn(4,TRUE);
  edit->setItemEnabled(copyItem,TRUE);
  shortcut->setOn(5,TRUE);

  
  if(wname==QString("MyClass"))
     {
       edit->setItemEnabled(cutItem,FALSE);
       shortcut->setOn(4,FALSE);
       edit->setItemEnabled(copyItem,FALSE);
       shortcut->setOn(5,FALSE);
     }
  
  if((wname!=QString("MyClass"))&&(wname!=QString("MyCanvas"))&&(wname!=QString("MyMenuBar")))
      code=AR;
  if((wname==QString("MyMenuBar"))&&(code!=ME))
    code=AR;
  if((code==MB)&&(wname!=QString("MyClass")))
    code=AR;
  
  if(event->button()==LeftButton)
    {
      if(PasteIT)
	{
	  copyWidget(widget,x,y);
	  return TRUE;
	}      
      if(code==AR)
	{
	  clicked=TRUE;
	  clickX=x;clickY=y;
	  undoX=widget->x();
	  undoY=widget->y();
	  undoW=widget->width();
	  undoH=widget->height();

	  watchWidget(widget);

	  if(active!=NULL)
	    delete active;

	  if(QString(widget->className())!=QString("MyClass"))
	    {
	      active=new Frame(widget->parentWidget(),"active");
	      setActive(widget,TRUE);
	    }
	  else
	    {
	      active=new Frame(widget,"active");
	      setActive(widget,FALSE);
	    }
	  widget->raise();
	}
      else  //if not an arrow
	{
	  if(lastTouched!=NULL)
	    lastTouched->counter++;
	 
	  
	  QString *tmpId=new QString(); 
	  tmpId->setNum(lastTouched->counter);
	  QString Id(widget->name());
	  int pos=Id.find(" ");
	  QString temp=Id.left(pos);
	  QString newId;newId+=temp;
	  newId+="|";
	  newId+=*tmpId;

	  if(code==PB)
	    {
	      QString newVN("push_button");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyPushButton *tmp=new MyPushButton("none",widget,name);
	      tmp->move(x,y);
	      tmp->resize(60,20);
	      createWidget(tmp,newId);
	    }
	  if(code==RB)
	    { 
	      QString newVN("radio_button");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyRadioButton *tmp=new MyRadioButton("none",widget,name);
	      tmp->move(x,y);
	      tmp->resize(60,20);
	      createWidget(tmp,newId);
	    }
	  if(code==CS)
	    {
	      QString newVN("canvas");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyCanvas *tmp=new MyCanvas(widget,name);
	      tmp->move(x,y);
	      tmp->resize(300,200);
	      createWidget(tmp,newId);
	    }
	  if(code==CO)
	    {
	      QString newVN("choice");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyChoice *tmp=new MyChoice(widget,name);
	      tmp->move(x,y);
	      tmp->resize(60,20);
	      createWidget(tmp,newId);
	    }
	  if(code==LI)
	    {
	      QString newVN("list");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyList *tmp=new MyList(widget,name);
	      tmp->move(x,y);
	      tmp->resize(100,50);
	      createWidget(tmp,newId);
	    }	    
	  if(code==TF)
	    {
	      QString newVN("text_field");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyTextField *tmp=new MyTextField(widget,name);
	      tmp->move(x,y);
	      tmp->resize(80,20);
	      createWidget(tmp,newId);
	    }	    	  
	  if(code==TA)
	    {
	      QString newVN("text_area");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyTextArea *tmp=new MyTextArea(widget,name);
	      tmp->move(x,y);
	      tmp->resize(150,100);
	      createWidget(tmp,newId);
	    }	    	  	  
	  if(code==SB)
	    {
	      QString newVN("scrollbar");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyScrollBar *tmp=new MyScrollBar(widget,name);
	      tmp->move(x,y);
	      tmp->resize(100,10);
	      createWidget(tmp,newId);
	    }	    	  	  	  
	  if(code==MB)
	    {
	      if(!lastTouched->getMenu())
		{
		  QString newVN("menubar");newVN+=*tmpId;
		  QString name;name=newId+" "+newVN;
		  MyMenuBar *tmp=new MyMenuBar(widget,name);
		  lastTouched->setMenu(tmp,TRUE);
		  tmp->move(0,0);
		  tmp->resize(lastTouched->width(),20);
		  createWidget(tmp,newId);
		}
	    }	    	  	  	  
	  if(code==ME)
	    {
	      if(QString(widget->className())==QString("MyMenuBar"))
		{
		  QString newVN("menu");newVN+=*tmpId;
		  QString name;name=newId+" "+newVN;
		  MyMenu *tmp=new MyMenu("none",widget,name);
		  ((MyMenuBar *)widget)->addMenu(tmp);
		  createWidget(tmp,newId);
		}
	    }	    	  
	  if(code==LA)
	    {
	      QString newVN("label");newVN+=*tmpId;
	      QString name;name=newId+" "+newVN;
	      MyLabel *tmp=new MyLabel("none",widget,name);
	      tmp->setAlignment(AlignCenter);
	      tmp->move(x,y);
	      tmp->resize(50,16);
	      createWidget(tmp,newId); 
	    }
	}
      code=AR;
    } //END of LeftButton
  else
    if(event->button()==RightButton)
      {
	if(active!=NULL)
	  delete active;
	if(QString(widget->className())!=QString("MyClass"))
	  {
	    active=new Frame(widget->parentWidget(),"active");
	    setActive(widget,TRUE);
	  }
	else
	  {
	    active=new Frame(widget,"active");
	    setActive(widget,FALSE);
	  }
	QPopupMenu *fastItem=new QPopupMenu();
	int cut,copy,paste;
	cut=fastItem->insertItem("Cut",this,SLOT(cut()));
	copy=fastItem->insertItem("Copy",this,SLOT(copy()));
	paste=fastItem->insertItem("Paste",this,SLOT(paste()));
	
	fastItem->setItemEnabled(paste,canPaste);
	
	fastItem->insertSeparator();
	fastItem->insertItem("Preferences",this,SLOT(prefs()));
	if(QString(widget->className())==QString("MyClass"))
	  {  
	    fastItem->move(lastTouched->x()+event->x(),lastTouched->y()+event->y()); 
	    fastItem->setItemEnabled(cut,FALSE);
	    fastItem->setItemEnabled(copy,FALSE);
	  }
	else
	  {
	    int tmpX=0,tmpY=0;
	    QString tmp=QString(widget->name());
	    QString hisID=tmp.left(tmp.find(" "));
	    tree[whichLast()].getXY(hisID,tmpX,tmpY);
	    fastItem->move(lastTouched->x()+tmpX+widget->x()+widget->width()+15,lastTouched->y()+tmpY+widget->y()+event->y());
	  }

	fastItem->setFocus();
	fastItem->show();
      } 
  return TRUE;
}

void MainWindow::takeRelease(QWidget *widget,QMouseEvent *event)
{
  clicked=FALSE;clickX=0;clickY=0;
}

void MainWindow::takeDbClick(QWidget *widget,QMouseEvent *event)
{
  prefs();
}

void MainWindow::setTouched(MyClass *widget)
{
  if((widget!=lastTouched) &&(widget!=NULL) )
    {
      canPrefs=TRUE;canSave=TRUE;canClose=FALSE;
      lastTouched=widget;
    }
  middle->changeProject(widget);
}

void MainWindow::createWidget(QWidget *widget,QString id)
{
  QString *f1[NUMFEATURE1];
  int f2[NUMFEATURE2],i;

  for(i=0;i<NUMFEATURE2;i++)
    f2[i]=-1;

  widget->setFont(QFont("courier",10));
 
  edit->setItemEnabled(cutItem,TRUE);
  shortcut->setOn(4,TRUE);
  edit->setItemEnabled(copyItem,TRUE);
  shortcut->setOn(5,TRUE);
  canClose=FALSE;canUndo=TRUE;undoProps=FALSE;
  edit->setItemEnabled(undoItem,TRUE);
  shortcut->setOn(7,TRUE);
  setUndo(widget,ADD);
  
  PasteIT=FALSE;
  widget->setMouseTracking(TRUE);
  connect(widget,SIGNAL(mv(QWidget *,QMouseEvent *)),SLOT(takeMove(QWidget *,QMouseEvent *)));
  connect(widget,SIGNAL(press(QWidget *,QMouseEvent *)),SLOT(takePress(QWidget *,QMouseEvent *)));
  connect(widget,SIGNAL(release(QWidget *,QMouseEvent *)),SLOT(takeRelease(QWidget *,QMouseEvent *))); 
  connect(widget,SIGNAL(dbclick(QWidget *,QMouseEvent *)),SLOT(takeDbClick(QWidget *,QMouseEvent *)));
  
  lastTouched->watchIt(widget); //podlacz dotyk do appletu
  widget->show();           
  lastTouched->setTraced(widget);
      
  if(active!=NULL)
    delete active;
  active=new Frame(widget->parentWidget(),"active");
  setActive(widget,TRUE);
  // add to tree

  for (i = 0; i < NUMFEATURE1; i++) 
	f1[i] = new QString(30);

  *f1[0] = id.copy();
  *f1[1] = widget->name();
  *f1[2] = widget->className();
  if(QString(widget->className())!=QString("MyTextField"))
    *f1[3] = "none";
  else
    *f1[3]="";
  f2[0] = NUMFEATURE2;
  f2[1] = widget->x();
  f2[2] = widget->y();
  f2[3] = widget->width();
  f2[4] = widget->height();
  
  QColor col;
  col = widget->backgroundColor();
  f2[5] = col.red();
  f2[6] = col.green();
  f2[7] = col.blue();
  col = widget->foregroundColor();
  f2[8] = col.red();
  f2[9] = col.green();
  f2[10] = col.blue();
  
  QFont f;
  f = widget->font();
  *f1[4] = f.family();
  f2[11] = f.pointSize();
  f2[12] = f.weight();
  if (f.italic() == TRUE) 
    f2[13] = 1;
  else 
    f2[13] = 0;

  f2[14]=0;  //subtree hidden
  if(QString(widget->className())==QString("MyScrollBar"))
    f2[20]=1;  //special for scrollbar (horizontal setting)  
  tree[whichLast()].Add(f1, f2);

  for (i = 0; i < NUMFEATURE1; i++) 
    if (f1[i]) delete f1[i];	     
}

void MainWindow::copyWidget(QWidget *widget,int x,int y,bool undo)
{
  int i,j,nn=0;
  QString *children[30],*f1t[NUMFEATURE1],id_parent,id,id_tmp,newid,tmp,to_search,root;
  int f2t[NUMFEATURE2];

  to_search=QString("1");
  for (i = 0; i < 30; i++) 
    children[i] = new QString(30);
 
  pasteTree->getSub(pasteTree->Find(&to_search),children,nn);
  id_parent=QString(widget->name());
  id=id_parent.left(id_parent.find(" "));

  for (i=0; i<NUMFEATURE1; i++) 
    f1t[i]=new QString(30);
  MyTree *tempTree;
  
  int realHelp[40];
  for(i=0;i<40;i++)
    realHelp[i]=0;

  for(i=0;i<nn;i++)
    {
      id_tmp=QString("");
      newid=QString("");
      tempTree=pasteTree->Find(children[i]);
      
      for(j=0;j<NUMFEATURE1;j++)
	*f1t[j]=tempTree->GetFeature1(j)->copy();
      
      int count=children[i]->contains("|");
      for(j=0;j<count;j++)
	{
	  if(realHelp[j]==0)
	    {
	      lastTouched->counter++;
	      id_tmp+=QString("|")+QString().setNum(lastTouched->counter);
	      realHelp[j]=lastTouched->counter;
	    }
	  else
	    id_tmp+=QString("|")+QString().setNum(realHelp[j]);
	}
      lastTouched->counter++;
      newid+=id+id_tmp+QString("|")+QString().setNum(lastTouched->counter);
      realHelp[j]=lastTouched->counter;


      *f1t[0]=newid.copy();
      newid+=f1t[1]->right(f1t[1]->length()-f1t[1]->find(" "));
      *f1t[1]=newid.copy();

      for(j=0;j<NUMFEATURE2;j++)
	f2t[j]=tempTree->GetFeature2(j);
      
      if(i==0)
	{
	  if(!undo)
	    {
	      f2t[1]=x;
	      f2t[2]=y;
	    }
	  root=f1t[0]->copy();
	}
      tree[whichLast()].Add(f1t,f2t);
    }
  PasteIT=FALSE;
  tempTree=tree[whichLast()].Find(&root);
  ShowWidget(tempTree,widget);
}




void MainWindow::doThis(int val)
{
  if(val==NEW)
    newOne();
  if(val==OPEN)
    open();
  if(val==SAVE)
    save();
  if(val==CUT)
    cut();
  if(val==COPY)
    copy();
  if(val==PASTE)
    paste();
  if(val==UNDO)
    undo();
  if(val==GN)
    gen();
  if(val==TR)
    classTree();
}

void MainWindow::display(const char *text)
{
  if(!PasteIT)
    helptext->disp(text);
}
void MainWindow::advertise()
{
  if(!PasteIT)
    helptext->adv();
}

void MainWindow::watchMouse(int x,int y)
{
  QString *sentence=new QString();
  *sentence+="X="+QString().setNum(x)+" Y="+QString().setNum(y);
  //  *sentence+=*tmpY;
  display(sentence->data());
}

void MainWindow::watchWidget(QWidget *widget)
{
  QString temp1=widget->name();
  int pos=temp1.findRev(" ");
  int hm=temp1.length()-pos;
  QString text;
  text+=temp1.right(hm-1);
  text+="  X="+QString().setNum(widget->x())+" Y="+QString().setNum(widget->y());
  text+=" W="+QString().setNum(widget->width());
  text+=" H="+QString().setNum(widget->height());
  display(text.data());
}

void MainWindow::in(int val,QWidget *wgt,QString *toPut)
{
  switch(val)
    {
    case AP:
    case WN:
    case FR:
      ((MyClass *)wgt)->evt.append(toPut);
      break;
    case PB:
       ((MyPushButton *)wgt)->evt.append(toPut);
      break;
    case RB:
       ((MyRadioButton *)wgt)->evt.append(toPut);
      break;
    case CO:
       ((MyChoice *)wgt)->evt.append(toPut);
      break;
    case CS:
       ((MyCanvas *)wgt)->evt.append(toPut);
      break;
    case LI:
       ((MyList *)wgt)->evt.append(toPut);
      break; 
    case TF:
       ((MyTextField *)wgt)->evt.append(toPut);
      break;       
    case TA:
       ((MyTextArea *)wgt)->evt.append(toPut);
      break;             
    case SB:
       ((MyScrollBar *)wgt)->evt.append(toPut);
      break;        
    case MB:
      ((MyMenuBar *)wgt)->evt.append(toPut);
      break;             
    case ME:
      ((MyMenu *)wgt)->evt.append(toPut);
      break;    
    case LA:
      ((MyLabel *)wgt)->evt.append(toPut);
      break;    
    default:
      printf("No such component\n");
    }
}

//left part
left::left(MainWindow* parent,const char* name):QFrame( parent, name,0 )
{ 
  QPixmap *pix;
  toSend=parent;
  QString tmp,path;
  
  setFrameStyle(Panel|Raised);

  tmp=parent->getBigPath();

  path=tmp+QString("images/select.xpm");

  b1 = new leftButton( this, "1",toSend,QPixmap(path.data()),QPixmap(path.data()));
  b1->sB(AR);
  b1->setText("select");
  b1->setGeometry(0,0, 25, 25 );
  connect(b1,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/button.xpm");

  b2 = new leftButton( this, "2",toSend,QPixmap(path.data()),QPixmap(path.data()));
  b2->sB(PB);
  b2->setText("button");
  b2->setGeometry(0,25, 25, 25 );
  connect(b2,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/checkbox.xpm");

  b3 = new leftButton( this, "3" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b3->sB(RB);
  b3->setText("check box");
  b3->setGeometry(25,25, 25, 25 );
  connect(b3,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/label.xpm");

  b4 = new leftButton( this, "4" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b4->sB(LA);
  b4->setText("label");
  b4->setGeometry(0,50, 25, 25 );
  connect(b4,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/choice.xpm");

  b5 = new leftButton( this, "5" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b5->sB(CO);
  b5->setText("choice");  
  b5->setGeometry(25,50, 25, 25 );
  connect(b5,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/list.xpm");

  b6 = new leftButton( this, "6" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b6->sB(LI);
  b6->setText("list");  
  b6->setGeometry(0,77, 25, 25 );
  connect(b6,SIGNAL(lPress(int)),SLOT(sendCode(int)));
  
  path=tmp+QString("images/scroll.xpm");

  b7 = new leftButton( this, "7" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b7->sB(SB);
  b7->setText("scrollbar"); 
  b7->setGeometry(25,77, 25, 25 );
  connect(b7,SIGNAL(lPress(int)),SLOT(sendCode(int)));  
  
  path=tmp+QString("images/text_area.xpm");

  b8 = new leftButton( this, "8" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b8->sB(TA);
  b8->setText("text area");
  b8->setGeometry(0,104, 25, 25 );
  connect(b8,SIGNAL(lPress(int)),SLOT(sendCode(int)));  

  path=tmp+QString("images/text.xpm");
  
  b9 = new leftButton( this, "9" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b9->sB(TF);
  b9->setText("text field");
  b9->setGeometry(25,104, 25, 25 );
  connect(b9,SIGNAL(lPress(int)),SLOT(sendCode(int)));  

  path=tmp+QString("images/menu.xpm");

  b10 = new leftButton( this, "10" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b10->sB(MB);
  b10->setText("menu bar");
  b10->setGeometry(0,131, 25, 25 );
  connect(b10,SIGNAL(lPress(int)),SLOT(sendCode(int)));  
	
  path=tmp+QString("images/menu_item.xpm"); 

  b11 = new leftButton( this, "11" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b11->sB(ME);
  b11->setText("menu");
  b11->setGeometry(25,131, 25, 25 );
  connect(b11,SIGNAL(lPress(int)),SLOT(sendCode(int))); 
  
  path=tmp+QString("images/canvas.xpm"); 

  b12 = new leftButton( this, "12" ,toSend,QPixmap(path.data()),QPixmap(path.data()));
  b12->sB(CS);
  b12->setText("canvas");
  b12->setGeometry(0, 157, 25, 25 );
  connect(b12,SIGNAL(lPress(int)),SLOT(sendCode(int)));   
  
  /*
  b13 = new leftButton( this, "13" ,toSend);
  b13->setGeometry(0, 125, 20, 20 );
  b13->setText("?");
  b13->setMouseTracking(TRUE);
  
  b14 = new leftButton( this, "14" ,toSend);
  b14->setGeometry(20, 125, 20, 20 );
  b14->setText("?");
  b14->setMouseTracking(TRUE);
  
  b15 = new leftButton( this, "15" ,toSend);
  b15->setGeometry(0, 145, 20, 20 );
  b15->setText("?");
  b15->setMouseTracking(TRUE);
  
  b16 = new leftButton( this, "16" ,toSend);
  b16->setGeometry(20, 145, 20, 20 );
  b16->setText("?");
  b16->setMouseTracking(TRUE);
  
  b17 = new leftButton( this, "17" ,toSend);
  b17->setGeometry(0, 165, 20, 20 );
  b17->setText("?");
  b17->setMouseTracking(TRUE);
  
  b18 = new leftButton( this, "18" ,toSend);
  b18->setGeometry(20,165, 20, 20 );
  b18->setText("?");
  b18->setMouseTracking(TRUE);

  b19 = new leftButton( this, "19" ,toSend);
  b19->setGeometry(0,185,20,20);
  b19->setText("?");
  b19->setMouseTracking(TRUE);
  
  b20 = new leftButton( this, "20" ,toSend);
  b20->setGeometry(20,185, 20, 20 );
  b20->setText("?");
  b20->setMouseTracking(TRUE);
  
  b21 = new leftButton( this, "21" ,toSend);
  b21->setGeometry(0,205, 20, 20 );
  b21->setText("?");
  b21->setMouseTracking(TRUE);
  
  b22 = new leftButton( this, "22" ,toSend);
  b22->setGeometry(20,205, 20, 20 );
  b22->setText("?");
  b22->setMouseTracking(TRUE);

  b23 = new leftButton( this, "23" ,toSend);
  b23->setGeometry(0,225, 20, 20 );
  b23->setText("?");
  b23->setMouseTracking(TRUE);
  
  b24 = new leftButton( this, "24" ,toSend);
  b24->setGeometry(20,225, 20, 20 );
  b24->setText("?");
  b24->setMouseTracking(TRUE);
  
  b25 = new leftButton( this, "25" ,toSend);
  b25->setGeometry(0,245, 20, 20 );
  b25->setText("?");
  b25->setMouseTracking(TRUE);
  
  b26 = new leftButton( this, "26" ,toSend);
  b26->setGeometry(20,245, 20, 20 );
  b26->setText("?");
  b26->setMouseTracking(TRUE);
  */  
  resize( 50,280 );
  setMinimumSize( 50,280 );
  setMaximumSize( 50,280);
}

left::~left()
{
}

//up

up::up(MainWindow *parent,const char* name):QFrame( parent, name, 0 )
{
  QPixmap *pix;
  toCall=parent;
  setFrameStyle(Panel|Raised);
 
  QString tmp,path1,path2;


  tmp=parent->getBigPath();

  path1=tmp+QString("images/new.xpm");
  path2=tmp+QString("images/new_off.xpm");

  b1 = new leftButton( this, "b1",toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b1->setGeometry( 0, 0, 30, 30 );
  b1->sB(NEW);
  b1->setText("new");
  connect(b1,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/open.xpm");
  path2=tmp+QString("images/open_off.xpm");
  
  b2 = new leftButton( this, "b2" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b2->setGeometry( 30, 0, 30, 30 );
  b2->sB(OPEN);
  b2->setText("open");
  connect(b2,SIGNAL(lPress(int)),SLOT(callIt(int)));
  
  path1=tmp+QString("images/save.xpm");
  path2=tmp+QString("images/save_off.xpm");

  b3 = new leftButton( this, "b3" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b3->setGeometry( 60, 0, 30, 30 );
  b3->sB(SAVE);
  b3->setText("save");
  connect(b3,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/cut.xpm");
  path2=tmp+QString("images/cut_off.xpm");
	
  b4 = new leftButton( this, "b4" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b4->setGeometry( 90, 0, 30, 30 );
  b4->sB(CUT);
  b4->setText("cut");
  connect(b4,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/copy.xpm");
  path2=tmp+QString("images/copy_off.xpm");
  
  b5 = new leftButton( this, "b5" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b5->setGeometry( 120, 0, 30, 30 );
  b5->sB(COPY);
  b5->setText("copy");
  connect(b5,SIGNAL(lPress(int)),SLOT(callIt(int)));  

  path1=tmp+QString("images/paste.xpm");
  path2=tmp+QString("images/paste_off.xpm");  
  
  b6 = new leftButton( this, "b6" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b6->setGeometry( 150, 0, 30, 30 );
  b6->sB(PASTE);
  b6->setText("paste");
  connect(b6,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/undo.xpm");
  path2=tmp+QString("images/undo_off.xpm");  
    
  b7 = new leftButton( this, "b7" ,toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b7->setGeometry( 180, 0, 30, 30 );
  b7->sB(UNDO);
  b7->setText("undo");
  connect(b7,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/generate.xpm");
  path2=tmp+QString("images/generate_off.xpm");  

  b8 =new leftButton(this ,"b8",toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b8->setGeometry( 230, 0, 30, 30 );
  b8->sB(GN);
  b8->setText("generate");
  connect(b8,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/tree.xpm");
  path2=tmp+QString("images/tree_off.xpm");    

  b9 =new leftButton(this ,"b9",toCall,QPixmap(path1.data()),QPixmap(path2.data()));
  b9->setGeometry( 260, 0, 30, 30 );
  b9->sB(TR);
  b9->setText("show class tree");
  connect(b9,SIGNAL(lPress(int)),SLOT(callIt(int)));

  path1=tmp+QString("images/logo.gif"); 

  Logo *lg=new Logo(QMovie(path1.data()),this);
  lg->setGeometry(300,0,50,30);

  resize( 470,30 );
  setMinimumSize( 470, 30 );
  setMaximumSize( 470, 30 );
}

up::~up()
{
}

//down panel

down::down(MainWindow* parent,const char* name):QFrame( parent, name, 0 )
{
  setFrameStyle(Panel|Sunken);
  neon = new QLabel( this, "neon" );
  neon->setGeometry( 10, 10,300, 20 );
  neon->setAlignment( 289 );
  neon->setText("welcome to BuildIT!");
  resize( 300,40 );
  setMinimumSize( 350, 40 );
  setMaximumSize( 350, 40 );
}

down::~down()
{}

//Button

void leftButton::enterEvent(QEvent *event)
{
  toDraw->display(text);
}

void leftButton::leaveEvent(QEvent *event)
{
  toDraw->advertise();
}


//Main


int main( int argc, char ** argv ,char **envp)
{
    QApplication a( argc, argv );

    if(argc>1)
      {
	printf("\n          GUI builder BuildIT! version 0.1.1\nCopyright 1998 Michal Switala & Artur Prusakiewicz\n\n");
	exit(0);
      }
  
    MainWindow m;
    a.setMainWidget( &m );
    m.show();
    return a.exec();
}















